#!/usr/local/bin/perl

use DBI;
use CGI qw/:standard :escape :unescape/;
use LWP::UserAgent;

$mailprog = '/bin/sendmail';

# These are valid scripts to call to generate unlock codes
$unlockers{'sswrap'} = 'http://www.3dshops.com/cgi-bin/sswrap.cgi';
$unlockers{'slgen'} = 'http://www.3dshops.com/cgi-bin/slgen.exe';
$unlockers{'failme'} = 'http://www.i-hope-this-does-not-exist.com/';
$default_unlocker = 'sswrap';

$unlock_timeout = 60;							# time out in 30 seconds

$email_alert = 'tech@3d3.com';					# email in case of fatal error
$email_contact = 'support@3d3.com';				# email address to give to client
$email_sales = 'mtv@3d3.com';					# email address to give in case of not paid
$email_regdb = 'tech@3d3.com';					# email of person who processes registrations
$name_from = 'Your ShopFactory Team';			# email to customer comes from this name
$email_from = 'support@3d3.com';				# email to customer comes from this address
$email_notify = 'tech@3d3.com';					# our notification email goes to this address

$database = 'regdb';
$user = 'x3d3';
$passwd = '4dcubed';

# Start returning a page...
print "Content-type: text/html\n\n";

# check required fields
&check_required;

my($code) = param('code');
for($code) { s/^\s+//; s/\s+$//; }
my($email) = param('email');
for($email) { s/^\s+//; s/\s+$//; }
my($product) = param('product');
for($product) { s/^\s+//; s/\s+$//; }
my($version) = param('version');
for($version) { s/^\s+//; s/\s+$//; }
my($mversion) = param('mversion');
for($mversion) { s/^\s+//; s/\s+$//; }
my($language) = param('language');
for($language) { s/^\s+//; s/\s+$//; }
my($unlocker) = param('unlocker');
for($unlocker) { s/^\s+//; s/\s+$//; }

my($unlock_url) = $unlockers{$unlocker};
if(!$unlock_url) {
	$unlocker = $default_unlocker;
	$unlock_url = $unlockers{$unlocker};
}

# connect to the database
$dbh = DBI->connect("DBI:mysql:$database", $user, $passwd);
if($dbh) {
	my($qproduct) = $dbh->quote($product);
	my($qversion) = $dbh->quote($version);
	my($qcode) = $dbh->quote($code);

	my($sql) =<<"__EOSQL__";
SELECT Reg.*, Product.LongName From Reg, Product
WHERE (Reg.ProductID = Product.ProductID) AND
	  (Reg.Code = $qcode) AND
	  (Reg.Version = $qversion) AND
	  (Product.Name = $qproduct)
__EOSQL__
	my($sth) = $dbh->prepare($sql);
	if($sth) {
		if($sth->execute) {
			if($sth->rows > 0) {

				# Got it!

				my($hashref) = $sth->fetchrow_hashref;

				# Check if it's been paid for...
				if($$hashref{'Paid'} == 0) {
					# It hasn't been paid for, tell the customer to
					# buy it.

					my($htmlbody) =<<"__EOBODY__";
<p>Thank you for evaluating $$hashref{'LongName'}.  Our records indicate
that you have not purchased this software.  To purchase, please
proceed to the following URL:
<a href="http://www.3d3.com/shop/enter.html?code=$code">http://www.3d3.com/shop/enter.html?code=$code</a></p>

<p>If you believe this to be in error, please contact <a href="mailto:$email_sales">$email_sales</a></p>
__EOBODY__
					&print_html("Thank You for Evaluating", $htmlbody);

				} else {
					# It's either been paid for, or will be soon (debtor),
					# so it's ok to register

					# Get the email address from the database
					my($email_db) = $$hashref{'Email'};
					my($email_same) = 1;

					# If it's blank, default it to the customer's entered email
					if(!$email_db) {
						$email_db = $email;
					}
					if($email_db ne $email) {
						# The email addresses do not match
						$email_same = 0;
					}

					if($$hashref{'RequestCust'} == 1) {
						# This record was marked as needing customer details...
						# Go get 'em...

						my($upg) = 0;
						if( ($$hashref{'ResellerID'} > 0) && ($$hashref{'Upgrade'}) ) {
							$upg = 1;
						}

						&request_customer_details($upg);

					} else {
						# We've got everything we need...

						# ...get an unlock code...
						my($ok, $data) = &generate_unlock_code($code, $email_db, $product, $version);

						if($ok) {
							# It's ok, email the customer
							my($body) =<<"__END_BODY__";
Hi,

Thank you for registering your copy of $$hashref{'LongName'}

The following data must be entered in the registration screen:

Code:     $code
Email:    $email_db
Password: $data

Regards,

$name_from
__END_BODY__
							&sendmail($email_db, $email_from, "Password for $$hashref{'LongName'}", $body);

							# notify us
							$notify_body =<<"__END_PRE__";
A copy of $$hashref{'LongName'} has just been registered.

Details:
Code:     $code
Email:    $email
Password: $data
Product:  $product
Version:  $version.$mversion
Language: $language
Unlocker: $unlocker

__END_PRE__
							&sendmail($email_notify, $email_db, "Registration notification for $$hashref{'LongName'}", $notify_body);

							if(!$$hashref{'DateRegistered'}) {
								my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
								if($hour < 10) { $hour = "0$hour"; }
								if($min < 10) { $min = "0$min"; }
								if($sec < 10) { $sec = "0$sec"; }
								$year += 1900;

								my ($strdate) = "'$year-" . ($mon+1) . "-$mday $hour:$min:$sec'";

								my($sqlupd) =<<"__EOSQL__";
UPDATE Reg SET DateRegistered=$strdate
WHERE (Code='$code') AND
      (ProductID=$$hashref{'ProductID'}) AND
      (Version=$version)
__EOSQL__
								my($sthupd) = $dbh->prepare($sqlupd);
								if($sthupd) {
									if($sthupd->execute) {
										$dateok = 1;
									}
								}
							}

						} else {
							# It's not ok, email one of us
							my($body) =<<"__EOBODY__";
A request for an unlock code has been submitted.
An error occured: $data

Code:     $code
Email:    $email_db
Product:  $product
Version:  $version.$mversion
Language: $language
Unlocker: $unlocker
__EOBODY__
							&sendmail($email_regdb, $email_db, "Manual ShopFactory Registration", $body);
						}

						# ...and tell the customer about it

						my($htmlbody) = "<p>Thank you for registering.</p>";
						if(!$email_same) {
							$htmlbody .= "<p>You entered $email as your email address, but you are";
							$htmlbody .= " currently in our database as $email_db</p>";
						}
						if($ok) {
							$htmlbody .= "<p>Your unlock password has been sent to $email_db</p>";
						} else {
							$htmlbody .= "<p>There was an error generating your unlock password.";
							$htmlbody .= " Your request will be processed manually and your unlock";
							$htmlbody .= " password will be sent to $email_db  You should";
							$htmlbody .= " receive a response within 24 hours.</p>";
						}
						&print_html("Thank You", $htmlbody);

					}
				}

			} else {

				# The combination of code, product and version does
				# not exist in the database...  tell the customer about it

				&print_invalid_code;

			}
			$sth->finish;
		} else {
			&print_html('Error: $sth->execute() Failed', $sth->errstr);
		}
	} else {
		&print_html('Error: $dbh->prepare() Failed', $dbh->errstr);
	}
	$dbh->disconnect;
} else {
	&print_html('Error: $dbh->connect() Failed', "Unable to connect to database - $dbh->errstr");
}

sub generate_unlock_code {
	my($code, $email, $product, $version) = @_;
	my($rval, $msg);

	my($url) = "$unlock_url";
	$url    .= "?code=" . escape($code);
	$url    .= "&email=" . escape($email);
	$url    .= "&product=" . escape($product);
	$url    .= "&version=" . escape($version);

	my($ua) = new LWP::UserAgent;
	my($req) = new HTTP::Request GET => $url;
	$ua->timeout($sswrap_timeout);
	my($res) = $ua->request($req);
	if($res->is_success) {
		my($c) = $res->content;
		my($result, $data) = ($c =~ /^(\w+)[:]\s+(.+)/g);
		if($result eq 'Unlock') {
			# We got an unlock code, it's stored in $data
			$rval = 1;
		} else {
			# There was an error in the unlocker, message is in $data
			$rval = 0;
		}
		$msg = $data;
	} else {
		# Unable to connect to the unlocker
		$rval = 0;
		$msg = "Unable to connect to $unlock_url or timeout";
	}
	if(!$rval) {
		$msg .= "\nURL is $url";
	}
	return($rval, $msg);
}

sub print_invalid_code {
	# check code for length = 12, all numbers or du-nnn-n+

	if ( (not ($code =~ /^[0-9]{12}?$/)) &&
		 (not ($code =~ /^[a-z]{2}?-[0-9]{3}?-[0-9]+?$/)) ) {

		# This is not a valid code...

		my($errmsg) =<<"__EOERR__";
<p>The code you have entered is not valid.  Your code is the twelve digit number
you received in your email receipt of purchase, or is the number on your CD-ROM.</p>
<p>Please <a href="$ENV{'HTTP_REFERER'}">go back</a> and try again.</p>
<p>If you believe this to be in error, please contact
<a href="mailto:$email_contact">$email_contact</a></p>
__EOERR__

		&print_html("Error: Invalid Code ($code)", $errmsg);

	} else {
		# It's a valid code, but the combination of code, product
		# and version isn't in the database

		my($errmsg) =<<"__EOERR__";
<p>The code you have entered is valid, but does not exist in our database
for the product you are trying to register ($product $version).</p>
<p>Please check the code you entered, then <a href="$ENV{'HTTP_REFERER'}">go back</a>
and try again.</p>
<p>If you believe this to be in error, please contact
<a href="mailto:$email_contact">$email_contact</a></p>
__EOERR__
		&print_html("Error: Code Not Found ($code)", $errmsg);
	}
}

sub request_customer_details {
	my($upg) = @_;

	my($bgcolor) = param('bgcolor');
	my($text_color) = param('text_color');
	my($link_color) = param('link_color');
	my($vlink_color) = param('vlink_color');
	my($alink_color) = param('alink_color');

	my($htmlbody) =<<"__EOHTML__";
<center>
<p>Please enter your details to register:</p>
<form action="regdb_updatecust.cgi" method="post">
<input type="hidden" name="bgcolor" value="$bgcolor">
<input type="hidden" name="text_color" value="$text_color">
<input type="hidden" name="link_color" value="$link_color">
<input type="hidden" name="vlink_color" value="$vlink_color">
<input type="hidden" name="alink_color" value="$alink_color">
<input type="hidden" name="code" value="$code">
<input type="hidden" name="product" value="$product">
<input type="hidden" name="version" value="$version">
	<table border="1" bgcolor="#ffef90">
		<tr>
			<th align="left">Name</th>
			<td colspan="3"><input type="text" size="40" name="customername"></td>
		</tr>
		<tr>
			<th align="left">Company</th>
			<td colspan="3"><input type="text" size="40" name="customercompany"></td>
		</tr>
		<tr>
			<th align="left">Street</th>
			<td colspan="3"><input type="text" size="40" name="customerstreet"></td>
		</tr>
		<tr>
			<th align="left">City</th>
			<td colspan="3"><input type="text" size="40" name="customercity"></td>
		</tr>
		<tr>
			<th align="left">State</th>
			<td><input type="text" size="20" name="customerstate"></td>
			<th align="left">Zip</th>
			<td><input type="text" size="8" name="customerzip"></td>
		</tr>
		<tr>
			<th align="left">Country</th>
			<td colspan="3"><input type="text" size="40" name="customercountry"></td>
		</tr>
		<tr>
			<th align="left">Phone</th>
			<td colspan="3"><input type="text" size="40" name="customerphone"></td>
		</tr>
		<tr>
			<th align="left">Fax</th>
			<td colspan="3"><input type="text" size="40" name="customerfax"></td>
		</tr>
		<tr>
			<th align="left">Email</th>
			<td colspan="3"><input type="text" size="40" name="customeremail" value="$email"></td>
		</tr>
	</tr>
</table>
__EOHTML__

	if($upg == 1) {
		$htmlbody .=<<"__EOHTML__";
<br>
<p>The product you are registering is an upgrade.  Please enter the Code from your
previous version of ShopFactory.</p>
<table border="1" bgcolor="#ffef90">
	<tr>
		<th align="left">Previous Code</th>
		<td colspan="3"><input type="text" size="40" name="oldcode"></td>
	</tr>
</table>
<input type="hidden" name="coc" value="1">
__EOHTML__
	}

	$htmlbody .=<<"__EOHTML__";
<br><input type="submit" value="Submit"> <input type="reset" value="Reset"></center>
</form>
__EOHTML__

	&print_html("Enter Customer Details", $htmlbody);
}

sub check_required {

	if( (!(param('email')) || param('email') eq ' ') ||
		(!(param('code')) || param('code') eq ' ') ) {

		# We haven't been sent email and/or code - this means the
		# client probably has JavaScript turned off.

		my($errmsg) =<<"__EOERR__";
<p>Your Email address and/or Code were not specified.  This probably means
that your browser does not support JavaScript, or you have JavaScript turned off.</p>
<p>Please enable JavaScript and try again.</p>
__EOERR__

		&print_html("Error: Email and Code Not Specified", $errmsg);
		&send_error_report('Email and/or Code not specified');

		exit;
	} else {
		# We have got email and code, check product and version...

		if( (!(param('product')) || param('product') eq ' ') ||
			(!(param('version')) || param('version') eq ' ') ) {

			# product or version does not exist

			my($errmsg) =<<"__EOERR__";
<p>The Product Name and Version information could not be correctly determined.
This could mean one of two things:</p>
<ol>
	<li><p>Your browser does not support JavaScript, or you have JavaScript
	turned off - please enable JavaScript and try again.</p>

	<li><p>You manually entered the URL of this page, or the previous page,
	Please press the &quot;Register&quot; button on the ShopFactory start up
	screen instead of doing this.</p>
</ol>
__EOERR__

			&print_html("Error: Can't determine Product and Version", $errmsg);
			&send_error_report('Product and/or Version not specified');

			exit;
		}
	}
}

sub send_error_report {
	my($error) = @_;
	my($body);

	$body  = "$date\n";
	$body .= "Error: $error\n";

	$body .= "\n----- Param Info -----\n\n";

	my (@names) = param;
	for $name (@names) {
		$body .= "$name = " . param($name) . "\n";
	}

	$body .= "\n----- UA Info -----\n\n";
	$body .= "Browser: $ENV{'HTTP_USER_AGENT'}\n";
	$body .= "Remote Host: $ENV{'REMOTE_HOST'}\n";
	$body .= "Remote Address: $ENV{'REMOTE_ADDR'}\n";

	&sendmail($email_alert,
		"\"regdb_register\" <$email_alert>",
		"regdb_register error!",
		$body);
}

sub print_html {
	my($title, $desc) = @_;

	print "<html>\n<body";
	&body_attributes;
	print ">\n";

	print <<"__EOHTML__";
<center>
<table border="0" cellpadding="0" cellspacing="0" width="540">
	<tr>
		<td>
			<font face="Arial, Helvetica">
			<center><h4>$title</h4></center>
			$desc
			</font>
		</td>
	</tr>
</table>
</center>
</body>
</html>
__EOHTML__
}

sub body_attributes {
	if (param('bgcolor')) {
		print " bgcolor=\"" . param('bgcolor') . "\"";
	}
	if (param('link_color')) {
		print " link=\"" . param('link_color') . "\"";
	}
	if (param('vlink_color')) {
		print " vlink=\"" . param('vlink_color') . "\"";
	}
	if (param('alink_color')) {
		print " alink=\"" . param('alink_color') . "\"";
	}
	if (param('text_color')) {
		print " text=\"" . param('text_color') . "\"";
	}
}

sub sendmail {
	my($to, $from, $subject, $body) = @_;

	open (MAIL, "|$mailprog -t -oi") || return 0;
	print MAIL "To: $to\n";
	print MAIL "From: $from\n";
	print MAIL "Subject: $subject\n\n";
	print MAIL "$body\n";
	close MAIL;
	return 1;
}
